/*
	Joseph Bergin, May. 1998
	Version 2.
	
	All of the events here conform to the pattern Component Listens to Itself. 
*/

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.net.*;

public class AllenApp extends Applet implements MouseListener
{	public AllenApp(Frame myFrame){ this.myFrame = myFrame;}
	private Frame myFrame;
	
	public void init() 
	{	resize(640, 480);
		setBackground(Color.yellow); 
		
		// Get a menu bar.
		MenuBar mb = myFrame.getMenuBar();
		if(mb == null)
		{ 	mb = new MenuBar();
			myFrame.setMenuBar(mb);
		}
		// Create a menu for the menu bar.
		activitiesMenu = new Menu("Activities", true);
		mb.add(activitiesMenu);
		//popup = new PopupMenu("Actiities");
		//myFrame.add(popup);
		// Add menu items to the menu.  Give each an ActionListener for its action.
		MenuItem item = new CyanMenuItem();
		activitiesMenu.add(item);
		//popup.add(item);
	
		item = new YellowMenuItem();
		activitiesMenu.add(item);
		//popup.add(item);
		
		item = new BeepMenuItem();
		activitiesMenu.add(item);

		item = new BoxMenuItem();
		activitiesMenu.add(item);
		
		item = new PictureMenuItem();
		activitiesMenu.add(item);
		
		item = new CircleMenuItem();
		activitiesMenu.add(item);
		
		item = new InfoMenuItem();
		activitiesMenu.add(item);
		
		// Create a modeless dialog box with two buttons.  
		yellowDialog = new Dialog(myFrame, "Your Wish is our command.",false);
		yellowDialog.setSize(200, 100);
		yellowDialog.setLocation(50, 50);
		yellowDialog.add("Center", new Label("Restore Yellow Background?"));
		Panel dialogPanel = new Panel();
		yellowDialog.add("South", dialogPanel);
		Button yesButton = new YesButton();
		Button noButton = new NoButton();
		dialogPanel.add("West", yesButton);
		dialogPanel.add("East", noButton);
		
		// Create a modal dialog box with one button. 
		infoDialog = new Dialog(myFrame, "Data on Screen and Current ViewPort.",true);
		infoDialog.setLocation(50, 50);
		infoPanel = new Panel();
		infoPanel.setFont(new Font("SanSerif", Font.PLAIN, 9));
		infoDialog.add(infoPanel);
		//Define the panel that will show the info in this dialog box. 
		infoPanel.add("North", new Label("Size of the screen and the window in pixels:"));
		myToolkit = getToolkit();
		Dimension d = myToolkit.getScreenSize(); // Doesn't change as we run.
		String lab = "screen's length = " + d.width 
										+ ", screen's height = " + d.height;
		infoPanel.add("Center", new Label( lab ));
		infoDialog.setSize(20 + infoPanel.getFontMetrics(infoPanel.getFont()).stringWidth(lab), 100);
		windowSize = new Label(""); // Will show current window size.  
		infoPanel.add("South", windowSize);
		Button okButton = new OKButton();
		infoDialog.add("South", okButton);
		
		// Handle mouse clicks in our window.  
//		addMouseListener(new MouseWatcher());
		addMouseListener(this);
				
		// Get the image displayed by menu Picture. 
		image = myToolkit.getImage("JBergin.jpg");
	}
	
	public boolean imageUpdate(Image image, int flags, int x, int y, int w, int h)
	{	if((flags & ALLBITS) != 0) 
		{	Graphics g = getGraphics();
			g.drawImage(image, 100, 100, AllenApp.this);
			g.dispose();
		}
		return true;
	}
/*	
	public void print()
	{	PrintJob printing = myToolkit.getPrintJob(myFrame, "Testing", null);
		if(printing == null)
			System.out.println("No print job");
		else
		{	Graphics drawer = printing.getGraphics();
			if(drawer == null) 
				System.out.println("No Graphics.");
			else
			{	paint(drawer);
				drawer.dispose();
			}
			printing.end();
		}
	}
	
	public void paint(Graphics g)
	{	g.drawString("Hello World", 100, 100);
	}
*/	
	private Menu activitiesMenu;
	private Dialog yellowDialog, infoDialog;
	private Panel infoPanel;
	private Label windowSize;
	private Toolkit myToolkit;
	private Image image;
	//PopupMenu popup;

	// Mouse event handling
	
	public void mouseClicked(MouseEvent e)
	{	Graphics g = getGraphics();
		int x = e.getX(), y = e.getY();
		if(e.getModifiers() == InputEvent.BUTTON3_MASK) // Right button (Ctrl click on Mac).
		{	Font font = new Font("Serif", Font.ITALIC, 10);
			g.setFont(font);
			g.setColor(Color.red);
			g.drawString("Right Click at:(" + x + "," + y + ")", x, y);
		}
		else // Other buttons.
			g.drawString("Left Click", x, y);
		g.dispose();
	}
	
	// The others do nothing
	public void mousePressed(MouseEvent e){};
	public void mouseEntered(MouseEvent e){};
	public void mouseExited(MouseEvent e){};
	public void mouseReleased(MouseEvent e){};
	
	// Inner Classes
	
	class CyanMenuItem extends MenuItem implements ActionListener // Menu Cyan
	{	public CyanMenuItem()
		{	super("Cyan", new MenuShortcut(KeyEvent.VK_A));
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	setBackground(new Color(200, 255, 255)); //pale Cyan (RGB)
			repaint();
		}
	}

	class YellowMenuItem extends MenuItem implements ActionListener // Menu Yellow...
	{	public YellowMenuItem()
		{	super("Yellow...");
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	yellowDialog.setVisible(true);
		}
	}

	class BeepMenuItem extends MenuItem implements ActionListener // Menu Beep
	{	public BeepMenuItem()
		{	super("Beep", new MenuShortcut(KeyEvent.VK_C));
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	myToolkit.beep();
		} // We could actually play an audio clip here. 
	}

	class BoxMenuItem extends MenuItem implements ActionListener // Menu Box
	{	public BoxMenuItem()
		{	super("Box", new MenuShortcut(KeyEvent.VK_D));
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	Graphics g = getGraphics();
			g.drawRect(10, 10, 90, 50); // x, y, width, height
			g.dispose();
		}
	}

	class PictureMenuItem extends MenuItem implements ActionListener // Menu Picture
	{	public PictureMenuItem()
		{	super("Picture", new MenuShortcut(KeyEvent.VK_E));
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	Graphics g = getGraphics();
			g.drawImage(image, 100, 100, AllenApp.this);			
			g.dispose();
		}
	}

	class CircleMenuItem extends MenuItem implements ActionListener // Menu Circle
	{	public CircleMenuItem()
		{	super("Circle", new MenuShortcut(KeyEvent.VK_F));
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	Graphics g = getGraphics();
			g.setColor(Color.green);
			g.drawOval(50, 80, 200, 200);
			g.dispose();
//		print();
		}
	}

	class InfoMenuItem extends MenuItem implements ActionListener // Menu Info
	{	public InfoMenuItem()
		{	super("Info...", new MenuShortcut(KeyEvent.VK_G));
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	Rectangle r = getBounds();		
			windowSize.setText("window's length = " + r.width + ", window's height = " + r.height);
			infoDialog.setVisible(true);
		}
	}

	class OKButton extends Button implements ActionListener // OK button for Info dialog.
	{	public OKButton()
		{	super("OK");
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	infoDialog.setVisible(false);
		}
	}

	class YesButton extends Button implements ActionListener // Yes button for Yellow... dialog.
	{	public YesButton()
		{	super("Yes");
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	yellowDialog.setVisible(false);
			setBackground(Color.yellow);
			repaint();
		}
	}

	class NoButton extends Button implements ActionListener // No button for Yellow... dialog.
	{	public NoButton()
		{	super("No");
			addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e)
		{	yellowDialog.setVisible(false);
		}
	}

/*	class MouseWatcher extends MouseAdapter // Mouse click handler.
	{	public void mouseClicked(MouseEvent e)
		{	Graphics g = getGraphics();
			int x = e.getX(), y = e.getY();
			if(e.getModifiers() == InputEvent.BUTTON3_MASK) // Right button (Ctrl click on Mac).
			{	Font font = new Font("Serif", Font.ITALIC, 10);
				g.setFont(font);
				g.setColor(Color.red);
				g.drawString("Right Click at:(" + x + "," + y + ")", x, y);
			}
			else // Other buttons.
				g.drawString("Left Click", x, y);
			g.dispose();
		}
		
		public void mousePressed(MouseEvent e)
		{	Graphics g = getGraphics();
			int x = e.getX(), y = e.getY();
			if(e.isPopupTrigger()) popup.show(myFrame, x, y);
			g.dispose();
		}

	}
*/
}
