import java.awt.*;

public class Connection extends Figure implements java.io.Serializable
{	protected Figure first;
	protected Figure second;

	public Connection(String label, Figure first, Figure second)
	{	super(label, 0,  0, 0, 0);
		this.first = first;
		this.second = second;
	}
	
	public void draw(Graphics g)
	{	int x1 = first.center().x, y1 = first.center().y, x2 = second.center().x, y2 = second.center().y;
		g.drawLine(x1, y1, x2, y2);
		Color c = g.getColor();
		g.setColor(Color.red);
		g.drawString(label, (x1 + x2)/2+2, (y1 + y2)/2-2);
		g.setColor(c);
	}
	
	public void drawOutline(Graphics g)
	{	int x1 = first.center().x, y1 = first.center().y, x2 = second.center().x, y2 = second.center().y;
		g.drawLine(x1, y1, x2, y2);		
	}
}

